Loading...
Searching...
No Matches
unity::shell::scopes::ScopeInterface Class Referenceabstract

Object representing scope instance, which exposes model(s) with results. More...

`#include <unity/shell/scopes/ScopeInterface.h>`

Inheritance diagram for unity::shell::scopes::ScopeInterface:
[legend]
Collaboration diagram for unity::shell::scopes::ScopeInterface:
[legend]

## Public Types

enum class | Status { Okay , NoInternet , NoLocationData , Unknown }
| Status info code following the last operation.

## Signals

void | showDash ()
| Signal requesting to show the dash.
void | hideDash ()
| Signal requesting to hide the dash.
void | gotoUri (QString const &uri)
| Signal requesting to open a uri.
void | previewRequested (QVariant const &result)
| Signal requesting to preview a result.
void | gotoScope (QString const &scopeId)
| Signal requesting to change the currently focused scope.
void | openScope (unity::shell::scopes::ScopeInterface *scope)
| Signal requesting to show a temporary scope.

## Public Member Functions

virtual Q_INVOKABLE void | activate (QVariant const &result, QString const &categoryId)=0
| Method used to activate a result.
virtual Q_INVOKABLE unity::shell::scopes::PreviewModelInterface * | preview (QVariant const &result, QString const &categoryId)=0
| Method used to preview a result.
virtual Q_INVOKABLE void | cancelActivation ()=0
| Cancels the current activation.
virtual Q_INVOKABLE void | closeScope (unity::shell::scopes::ScopeInterface *scope)=0
| Closes the temporary scope which got opened when openScope was emitted.
virtual Q_INVOKABLE unity::shell::scopes::NavigationInterface * | getNavigation (QString const &navigationId)=0
| Get a NavigationInterface instance for the passed navigationId.
virtual Q_INVOKABLE void | setNavigationState (QString const &navId)=0
| Request change to the current navigation id.
virtual Q_INVOKABLE void | performQuery (QString const &cannedQuery)=0
| Execute canned query.
virtual Q_INVOKABLE void | refresh ()=0
| Force refresh of the scope contents.
virtual Q_INVOKABLE void | resetPrimaryNavigationTag ()=0
| Reset primary navigation filter and its tag in the search bar.
virtual Q_INVOKABLE void | resetFilters ()=0
| Reset filters to default values.
virtual Q_INVOKABLE void | activateAction (QVariant const &result, QString const &categoryId, QString const &actionId)=0

## Properties

QString | id
| Id of the scope.
QString | name
| Display name of the scope.
QString | iconHint
| URI to scope's icon.
QString | description
| Description of the scope.
QString | searchHint
| Hint to display in the search field.
bool | searchInProgress
| Boolean specifying whether a search is currently running.
bool | activationInProgress
| Boolean specifying whether an activation request is currently running.
bool | favorite
| Boolean specifying whether the scope is favourited.
QString | shortcut
| Keyboard shortcut used to summon the scope.
unity::shell::scopes::CategoriesInterface * | categories
| Categories model for scope's results.
unity::shell::scopes::SettingsModelInterface * | settings
| Settings model for the scope.
unity::shell::scopes::FilterBaseInterface * | primaryNavigationFilter
QString | searchQuery
| Current search query.
QString | noResultsHint
| Message to display when there are no results after a search.
QString | formFactor
| Form factor which is sent with search queries.
bool | isActive
| Boolean specifying whether the scope is currently active.
QString | currentNavigationId
| String specifying currently selected department.
bool | hasNavigation
| Boolean specifying whether current query has departments.
QVariantMap | customizations
| VariantMap with customization properties.
unity::shell::scopes::ScopeInterface::Status | status
| Enum representing the status of the scope.
unity::shell::scopes::FiltersInterface * | filters
| Filters model for the scope.
QString | primaryNavigationTag
| Label for the currently active top level navigation (department or primary filter).
int | activeFiltersCount
| The number of currently selected filters.

## Detailed Description

Object representing scope instance, which exposes model(s) with results.

## Member Function Documentation

## gotoUri

void unity::shell::scopes::ScopeInterface::gotoUri | ( | QString const & | uri | ) |

signal

Signal requesting to open a uri.

This signal is usually emitted after activating a result.

## hideDash

void unity::shell::scopes::ScopeInterface::hideDash | ( |  | ) |

signal

Signal requesting to hide the dash.

This signal is usually emitted after activating a result.

## preview()

virtual Q_INVOKABLE unity::shell::scopes::PreviewModelInterface * unity::shell::scopes::ScopeInterface::preview | ( | QVariant const & | result,
|  | QString const & | categoryId )

pure virtual

Method used to preview a result.

Returns a new PreviewModelInterface instance. It's caller's responsibility to free it.

## previewRequested

void unity::shell::scopes::ScopeInterface::previewRequested | ( | QVariant const & | result | ) |

signal

Signal requesting to preview a result.

This signal is usually emitted after activating a result.

## showDash

void unity::shell::scopes::ScopeInterface::showDash | ( |  | ) |

signal

Signal requesting to show the dash.

This signal is usually emitted after activating a result.

## Property Documentation

## formFactor

QString unity::shell::scopes::ScopeInterface::formFactor

read write

Form factor which is sent with search queries.

Form factor is one of scope inputs and be used by it to fine-tune the results.

TODO Document the supported for factors

## searchQuery

QString unity::shell::scopes::ScopeInterface::searchQuery

read write

Current search query.

Writing to this property issues a new search to the scope.

The documentation for this class was generated from the following file:

- include/unity/shell/scopes/ScopeInterface.h